# -*- coding: utf-8 -*-
##############################################################################
#
#    Original Module for OpenERP, Open Source Management Solution
#    Copyright (C) 2014 TeMPO CONSULTING (<http://tempo-consulting.fr>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""
DEPLOY SALEPERSONS USERS FROM COMPANIES CONTACTS
COMPANY TABLE (from T_Agences.csv) and COMPANY CONTACTS (from personel.csv)
AND COMPANY USERS (one user per company name with cie name as name) (users.csv)
MUST BE IMPORTED FIRST
"""
import xmlrpclib
import csv


username = 'admin'  # the user
pwd = 'axima'  # the password of the user
dbname = 'AXIMA'  # the database

# Get the uid
sock_common = xmlrpclib.ServerProxy('http://localhost:7069/xmlrpc/common')
uid = sock_common.login(dbname, username, pwd)

# replace localhost with the address of the server
sock = xmlrpclib.ServerProxy('http://localhost:7069/xmlrpc/object')
    
errors = []

DEFAULT_PWD = 'test'


"""
HELPERS
"""
def get_login_from_name(name):
    parts = name.split(" ")
    lparts = len(parts)
    if lparts > 1:
        res = parts[0][0]
        i = 1
        while i < lparts:
            res += parts[i]
            i += 1
        return res.lower()
    else:
        return name
         
def add_err(description):
    msg = "! ERROR / %s" % (description, )
    errors.append(msg)
    

"""
SCRIPT
"""
domain = [('parent_id', '!=', False)]  # get offices (not HQ)
fields_company = ['name', 'partner_id']
fields_company_partner = ['child_ids']
fields_contact_partner = ['name']
ids = sock.execute(dbname, uid, pwd, 'res.company', 'search', domain)
for r_company in sock.execute(dbname, uid, pwd, 'res.company', 'read', ids,
    fields_company):
    if r_company['name']:
        print "\n-----\nCOMPANY: %s" % (r_company['name'], )
        # get office user
        domain_company_user = [('name', '=', r_company['name'])]
        ids_company_user = sock.execute(dbname, uid, pwd, 'res.users', 'search',
            domain_company_user)
        if ids_company_user:
            print 'USER FOUND (%s)' % (str(ids_company_user), )
            if r_company['partner_id']:
                # get office partner
                print 'PARTNER: %s' % (r_company['partner_id'][1], )
                r_company_partner = sock.execute(dbname, uid, pwd, 'res.partner',
                    'read', r_company['partner_id'][0], fields_company_partner)
                if r_company_partner and r_company_partner['child_ids']:
                    # read office partner childs -> contacts/salepersons
                    for r_contact_partner in sock.execute(dbname, uid, pwd,
                        'res.partner', 'read', r_company_partner['child_ids'],
                        fields_contact_partner):
                        print 'SALEPERSON %s (%s)' % (r_contact_partner['name'],
                            get_login_from_name(r_contact_partner['name']), )
        else:
            print 'USER NOT FOUND'
            add_err("User not found for company: %s" % (r_company['name'], ))
            
if errors:
    for err in errors:
        print err
    print "%d errors" % (len(errors), )
# EOF
