#!/bin/sh
# Installation de l’environnement pour faire fonctionner la maquette AXIA

# Variables globales
rep_dir=~/OpenERP
server_branch=lp:openobject-server/7.0
server_directory=server
addons_branch=lp:openobject-addons/7.0 
addons_directory=addons
# web_branch=lp:openerp-web/7.0 web 
# on utilise la branche tempo contenant le widget percentage
web_branch=lp:tempo-openerp/~openerp-web/percentage-widget/
web_directory=web

light_install=yes # permute le téléchargement des dépôts avec ou sans l'historique 

if [ -d "$rep_dir" ]; then
    echo "Le répertoire $rep_dir existe déjà, annulation de l'installation"
    exit
fi

# Mise à jour du système et installation des dépendances, paramétrages
sudo apt-get update && sudo apt-get upgrade
sudo apt-get -y install bzr
# psql
sudo apt-get -y install postgresql
sudo su - postgres -c "createuser --createdb --username postgres --no-createrole --pwprompt $USER"

# python dependancies
sudo apt-get install -y python-dateutil python-docutils python-feedparser python-gdata python-jinja2 python-ldap python-libxslt1 python-lxml python-mako python-mock python-openid python-psycopg2 python-psutil python-pybabel python-pychart python-pydot python-pyparsing python-reportlab python-simplejson python-tz python-unittest2 python-vatnumber python-vobject python-webdav python-werkzeug python-xlwt python-yaml python-zsi
 
# last gdata-python-client
wget http://gdata-python-client.googlecode.com/files/gdata-2.0.17.tar.gz
tar zxvf gdata-2.0.17.tar.gz
rm gdata-2.0.17.tar.gz
cd gdata-2.0.17/
sudo python setup.py install


# Récupération des dépôts
mkdir -p $rep_dir
cd $rep_dir
bzr init-repo .
if [ light_install = true ]
then 
    bzr checkout --lightweight $server_branch $server_directory
    bzr checkout --lightweight $addons_branch $addons_directory
    bzr checkout --lightweight $web_branch $web_directory
    # plutôt que :
    #bzr checkout --lightweight 
else
    bzr branch lp:openobject-server/7.0 server # ou 
    bzr branch lp:openobject-addons/7.0 addons # ou 
    bzr branch lp:tempo-openerp/~openerp-web/percentage-widget/ web
fi


# utilisation du module axima
# il faut préalablement récupérer le dépôt du module AXIMA
# bzr clone bzr+ssh://bazaar.launchpad.net/~tempo-openerp/+junk/axima/

## récupération de la bdd
